#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <assert.h>
#include <xalloc.h>
/* Don't include general.h here! */

#ifdef DEB

void sfree(void ** ptr)
	{
	if (ptr != NULL)
		{
		if (*ptr != NULL)
			{
			chk_free(*ptr);
			*ptr = NULL;
			}
		}
	}


void * smalloc(size_t size)
	{
	register void * rtn = NULL;

	if (size != 0)
		{
		rtn = chk_malloc(size);
		memset(rtn, '\0', size);
		}
	return rtn;
	}

void * srealloc(void * ptr, size_t size)
	{
	if (ptr == NULL)
		return smalloc(size);
	else
		return chk_realloc(ptr, size);
	}
#endif

void * safe_realloc(void * ptr, size_t size)
	{
	if (ptr == NULL)
#ifdef DEB
		return smalloc(size);
#else
		return malloc(size);
#endif
	else
#ifdef DEB
		return srealloc(ptr, size);
#else
		return realloc(ptr, size);
#endif
	}


